package jsystem;


// A growable byte array
public class Buffer{

	private byte[] buf;
	private int pos = 0;
	private int inc = 8096;
	
	public Buffer(int initialsize){
		buf = new byte[initialsize];
		inc = initialsize;
	}
	
	public Buffer(){
		this(8096);
	}
	
	
	public void append(byte b){
		if(pos>=buf.length){
			byte[] bn = new byte[buf.length+inc];
			System.arraycopy(buf,0,bn,0,buf.length);
			buf = bn;
		}
		buf[pos++] = b;
	}
	
	public void append(byte[] b, int nbytes){
		if(nbytes<0 || nbytes>b.length)
			return;
		if(pos+nbytes>buf.length){
			byte[] bn = new byte[pos+nbytes];
			System.arraycopy(buf,0,bn,0,pos);
			buf = bn;
		}
		System.arraycopy(b,0,buf,pos,nbytes);
		pos+=nbytes;
	}
	
	public byte[] getBytes(){
		if(pos==buf.length)
			return buf;
		byte[] b = new byte[pos];
		System.arraycopy(buf,0,b,0,pos);
		return b;
	}
}
		
