package kjava.awt;

import java.util.*;


public class Container extends Component{
    LayoutManager lm=null;

    Vector components=new Vector();

    public void add(Component c){
           add(null, c);
    }

    public void setLayout(LayoutManager lm){
         this.lm = lm;
    }

    public void validate(){
         if(lm!=null)
              lm.layoutContainer(this);
    }

    public void add(String s, Component c){
          components.addElement(c);
          c.parent = this;
          lm.addLayoutComponent(s, c);
          lm.layoutContainer(this);
    }

    public void paint(javax.microedition.lcdui.Graphics g){
          super.paint(g);
          paintComponents( g );
    }


    public void paintComponents(javax.microedition.lcdui.Graphics g){
          lm.layoutContainer(this);
          for(int i=0; i<components.size(); i++){
              Component c = (Component)components.elementAt(i);
              g.translate(c.X, c.Y);
              //g.setClip(0,0,c.width,c.height);
              c.paint(g);
              g.translate(-c.X, -c.Y);
              //g.setClip(0,0,width,height);
          }
    }

    public Event getClickEvent(int x, int y){
          for(int i=0; i<components.size(); i++){
              Component c = (Component)components.elementAt(i);
              Event e = c.getClickEvent(x-c.X, y-c.Y);
              if(e!=null)
                  return e;
          }
          return null;
    }          

    public Event getMoveEvent(int x, int y){
          for(int i=0; i<components.size(); i++){
              Component c = (Component)components.elementAt(i);
              Event e = c.getMoveEvent(x-c.X, y-c.Y);
              if(e!=null)
                  return e;
          }
          return null;
    }
	
	public Event getReleaseEvent(int x, int y){
       for(int i=0; i<components.size(); i++){
              Component c = (Component)components.elementAt(i);
              Event e = c.getReleaseEvent(x-c.X, y-c.Y);
              if(e!=null)
                  return e;
        }
        return null;
    }
            


}
    
